import { select } from 'd3';
const svg = select('svg');
const width = document.body.clientWidth;
const height = document.body.clientHeight;
svg.attr('width', width).attr('height', height)


const render= (block,project) => {

}

async function fetchGeoJSON(){
  let geoJSONBundle = {}
	let blockJSON = await d3.json('block.json');
  let projectJSON = await d3.json('project.json');
  geoJSONBundle.blockJSON = blockJSON.features;
  geoJSONBundle.projectJSON = projectJSON.features;
  return geoJSONBundle;
}

const monthWiseCSV = (data) =>{
	let month = {'Aug':[],'Sep':[],'Oct':[]}
  data.forEach(d=>{
  let temp = {};
  temp.block_n = d.block_n 
  temp.mdrtly_stntd = +d.mdrtly_stntd
  temp.svrly_stntd = +d.svrly_stntd
  temp.svr_wstg = +d.svr_wstg
  temp.mdrtly_wstd = +d.mdrtly_wstd
  temp.svrly_uw = +d.svrly_uw
  temp.mdrtly_uw = +d.mdrtly_uw
  temp.nb_lbw = +d.nb_lbw
  temp.svrly_wasting_percent = +d.svrly_wasting_percent
  temp.wasting_percent = +d.wasting_percent
  temp.svrly_stunting_percent = +d.svrly_stunting_percent
  temp.stunting_percent = +d.stunting_percent
  temp.svrly_underweight_percent = +d.svrly_underweight_percent
  temp.underweight_percent = +d.underweight_percent
  temp.low_birth_weight_percent = +d.low_birth_weight_percent
  month[d.month_n].push(temp)
  })
return month;
}

const addProperty = (data,geojson) =>{
	for (let i = 0; i < data.length; i++) {
    let dataBlock = data[i].block_n;
  	for (let j = 0; j < geojson.length; j++){
    	let geojsonBlock = geojson[j].properties.Block;
      if(dataBlock == geojsonBlock){
				geojson[j].properties.mdrtly_stntd = data[i].mdrtly_stntd 
        geojson[j].properties.svrly_stntd = data[i].svrly_stntd	
        geojson[j].properties.svr_wstg = data[i].svr_wstg
        geojson[j].properties.mdrtly_wstd = data[i].mdrtly_wstd
        geojson[j].properties.svrly_uw = data[i].svrly_uw
        geojson[j].properties.mdrtly_uw = data[i].mdrtly_uw
        geojson[j].properties.nb_lbw = data[i].nb_lbw
        geojson[j].properties.svrly_wasting_percent = data[i].svrly_wasting_percent
        geojson[j].properties.wasting_percent = data[i].wasting_percent
        geojson[j].properties.svrly_stunting_percent = data[i].svrly_stunting_percent
        geojson[j].properties.stunting_percent = data[i].stunting_percent
        geojson[j].properties.svrly_underweight_percent = data[i].svrly_underweight_percent
        geojson[j].properties.underweight_percent = data[i].underweight_percent
        geojson[j].properties.low_birth_weight_percent = data[i].low_birth_weight_percent     
      }
      
    }
  }

}
async function mergeData(geoJSON){
  //merging block data
	let blockGeoJSON = geoJSON.blockJSON;
  let blockCSV = await d3.csv('block.csv');
  let blockMonthWiseCSV = monthWiseCSV(blockCSV);
  let blockGeoJSONAug = JSON.parse(JSON.stringify(blockGeoJSON));
  let blockGeoJSONSep = JSON.parse(JSON.stringify(blockGeoJSON));
  let blockGeoJSONOct = JSON.parse(JSON.stringify(blockGeoJSON));
  //call by reference so need to return
  addProperty(blockMonthWiseCSV.Aug,blockGeoJSONAug);
  addProperty(blockMonthWiseCSV.Sep,blockGeoJSONSep);
  addProperty(blockMonthWiseCSV.Oct,blockGeoJSONOct);
	const mergedBlock = {'Aug':blockGeoJSONAug,'Sep':blockGeoJSONSep,'Oct':blockGeoJSONOct}
  //merging project data
  let projectGeoJSON = geoJSON.projectJSON;
	let projectCSV = await d3.csv('project.csv');
  let projectMonthWiseCSV = monthWiseCSV(projectCSV);
  let projectGeoJSONAug = JSON.parse(JSON.stringify(projectGeoJSON));
  let projectGeoJSONSep = JSON.parse(JSON.stringify(projectGeoJSON));
  let projectGeoJSONOct = JSON.parse(JSON.stringify(projectGeoJSON));
  addProperty(projectMonthWiseCSV.Aug,projectGeoJSONAug);
  addProperty(projectMonthWiseCSV.Sep,projectGeoJSONSep);
  addProperty(projectMonthWiseCSV.Oct,projectGeoJSONOct);
  const mergedProject = {'Aug':projectGeoJSONAug,'Sep':projectGeoJSONSep,'Oct':projectGeoJSONOct}
  
  render(mergedBlock,mergedProject)
}

fetchGeoJSON().then(mergeData)
